
package de.ivu.elect.business.wahllokalsystem.boundary;

import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.wahllokalsystem.entity.WahllokalsystemStatus;

@RequestScoped
@Named(WahllokalsystemStatusConversationSelect.COMPONENT_NAME)
public class WahllokalsystemStatusConversationSelect implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "wahllokalsystemStatusConversationSelect";

  @Inject
  protected transient WahllokalsystemStatusExtendedDAO entityDAO;

  @Inject
  @ConversationGroup(WahllokalsystemStatusConversationStore.class)
  protected transient WahllokalsystemStatusConversationStore conversationStore;

  public WahllokalsystemStatusConversationSelect() {
    super();
  }

  public boolean isSelected() {
    return getEntityPK() != null;
  }

  public WahllokalsystemStatus getEntity() {
    return getEntityInternal();
  }

  private WahllokalsystemStatus getEntityInternal() {
    if (getEntityPK() == null) {
      return null;
    }

    return attach(getEntityPK());
  }

  public void setEntity(WahllokalsystemStatus entity) {
    setEntityAttached(attach(entity));
  }

  public void setEntity( de.ivu.elect.business.wahllokalsystem.entity.WahllokalsystemStatusPK  pk) {
    setEntityAttached(attach(pk));
  }

  protected void setEntityAttached(WahllokalsystemStatus entity) {
    if(entity == null) {
      setEntityPK(null);
    } else {
      setEntityPK(entity.getPk());
    }
  }

  public
    de.ivu.elect.business.wahllokalsystem.entity.WahllokalsystemStatusPK
   getEntityPK() {
    return conversationStore.getEntityPK();
  }

  public void setEntityPK(
    de.ivu.elect.business.wahllokalsystem.entity.WahllokalsystemStatusPK
   entityPK) {
    conversationStore.setEntityPK(entityPK);
  }

  protected WahllokalsystemStatus attach(WahllokalsystemStatus entity) {
    if (entity == null){
      return null;
    }

    return attach(entity.getPk());
  }

  protected WahllokalsystemStatus attach( de.ivu.elect.business.wahllokalsystem.entity.WahllokalsystemStatusPK  pk) {
    if (pk == null) {
      return null;
    }

    return entityDAO.findByPrimaryKey(pk);
  }

  public void clearEntity() {
    setEntityPK(null);

    conversationStore.close();
  }
}
